<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_25) on Tue Nov 07 17:12:39 PST 2017 -->
<title>BrowserSession</title>
<meta name="date" content="2017-11-07">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="BrowserSession";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../xdc/services/spec/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../xdc/services/spec/Attr.html" title="class in xdc.services.spec"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../xdc/services/spec/Cache.html" title="class in xdc.services.spec"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?xdc/services/spec/BrowserSession.html" target="_top">Frames</a></li>
<li><a href="BrowserSession.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields_inherited_from_class_xdc.services.spec.Session">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">xdc.services.spec</div>
<h2 title="Class BrowserSession" class="title">Class BrowserSession</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../xdc/services/spec/Session.html" title="class in xdc.services.spec">xdc.services.spec.Session</a></li>
<li>
<ul class="inheritance">
<li>xdc.services.spec.BrowserSession</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="strong">BrowserSession</span>
extends <a href="../../../xdc/services/spec/Session.html" title="class in xdc.services.spec">Session</a></pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_xdc.services.spec.Session">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;xdc.services.spec.<a href="../../../xdc/services/spec/Session.html" title="class in xdc.services.spec">Session</a></h3>
<code><a href="../../../xdc/services/spec/Session.html#msg">msg</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#BrowserSession()">BrowserSession</a></strong>()</code>
<div class="block">Create a session to browse the current package path.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#BrowserSession(xdc.services.global.Env)">BrowserSession</a></strong>(xdc.services.global.Env&nbsp;env)</code>
<div class="block">Create a new session with a given environment</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#BrowserSession(xdc.services.global.Env, xdc.services.spec.Cache)">BrowserSession</a></strong>(xdc.services.global.Env&nbsp;env,
              <a href="../../../xdc/services/spec/Cache.html" title="class in xdc.services.spec">Cache</a>&nbsp;cache)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#BrowserSession(java.lang.String[])">BrowserSession</a></strong>(java.lang.String[]&nbsp;dirs)</code>
<div class="block">Create a new session with a given package path</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#BrowserSession(java.lang.String[], xdc.services.global.Env)">BrowserSession</a></strong>(java.lang.String[]&nbsp;dirs,
              xdc.services.global.Env&nbsp;env)</code>
<div class="block">Create a new session with a given package path and environment</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../xdc/services/spec/Pkg.html" title="class in xdc.services.spec">Pkg</a></code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#findPkg(java.lang.String)">findPkg</a></strong>(java.lang.String&nbsp;qn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#getLoadDocs()">getLoadDocs</a></strong>()</code>
<div class="block">Return whether documentation is available in this session.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#getVers()">getVers</a></strong>()</code>
<div class="block">This function is a replacement for simply reading cmd.Builder.GREEN_VERS.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#isCurrentPkg(xdc.services.spec.Pkg)">isCurrentPkg</a></strong>(<a href="../../../xdc/services/spec/Pkg.html" title="class in xdc.services.spec">Pkg</a>&nbsp;pkg)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#isCurrentPkg(java.lang.String, java.lang.String)">isCurrentPkg</a></strong>(java.lang.String&nbsp;cpath,
            java.lang.String&nbsp;qn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#isPkgDir(java.lang.String)">isPkgDir</a></strong>(java.lang.String&nbsp;dir)</code>
<div class="block">Check whether the named directory contains a built package.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../xdc/services/spec/Pkg.html" title="class in xdc.services.spec">Pkg</a></code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#loadPkg(java.lang.String, java.lang.String)">loadPkg</a></strong>(java.lang.String&nbsp;dir,
       java.lang.String&nbsp;qn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../xdc/services/spec/Unit.html" title="class in xdc.services.spec">Unit</a></code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#loadUnit(java.lang.String)">loadUnit</a></strong>(java.lang.String&nbsp;name)</code>
<div class="block">Load the named unit's spec object by searching the package path.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#scanDirectories()">scanDirectories</a></strong>()</code>
<div class="block">Return a Map of package names indexed by the canonical path to
 the package's base.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#scanRepositories()">scanRepositories</a></strong>()</code>
<div class="block">Return a Map all package base directories indexed by the package's
 name.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/spec/BrowserSession.html#setLoadDocs(boolean)">setLoadDocs</a></strong>(boolean&nbsp;loadDocs)</code>
<div class="block">Set whether this session should preserve docs in Nodes.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_xdc.services.spec.Session">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;xdc.services.spec.<a href="../../../xdc/services/spec/Session.html" title="class in xdc.services.spec">Session</a></h3>
<code><a href="../../../xdc/services/spec/Session.html#findDecl(java.lang.String)">findDecl</a>, <a href="../../../xdc/services/spec/Session.html#findDecl(xdc.services.spec.Unit, java.lang.String)">findDecl</a>, <a href="../../../xdc/services/spec/Session.html#findUnit(xdc.services.spec.Pkg, java.lang.String)">findUnit</a>, <a href="../../../xdc/services/spec/Session.html#findUnit(java.lang.String)">findUnit</a>, <a href="../../../xdc/services/spec/Session.html#getEnv()">getEnv</a>, <a href="../../../xdc/services/spec/Session.html#setEnv(xdc.services.global.Env)">setEnv</a>, <a href="../../../xdc/services/spec/Session.html#setErr(java.io.PrintWriter)">setErr</a>, <a href="../../../xdc/services/spec/Session.html#setWarnings(boolean)">setWarnings</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="BrowserSession()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BrowserSession</h4>
<pre>public&nbsp;BrowserSession()</pre>
<div class="block">Create a session to browse the current package path.</div>
</li>
</ul>
<a name="BrowserSession(xdc.services.global.Env)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BrowserSession</h4>
<pre>public&nbsp;BrowserSession(xdc.services.global.Env&nbsp;env)</pre>
<div class="block">Create a new session with a given environment</div>
</li>
</ul>
<a name="BrowserSession(xdc.services.global.Env, xdc.services.spec.Cache)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BrowserSession</h4>
<pre>public&nbsp;BrowserSession(xdc.services.global.Env&nbsp;env,
              <a href="../../../xdc/services/spec/Cache.html" title="class in xdc.services.spec">Cache</a>&nbsp;cache)</pre>
</li>
</ul>
<a name="BrowserSession(java.lang.String[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BrowserSession</h4>
<pre>public&nbsp;BrowserSession(java.lang.String[]&nbsp;dirs)</pre>
<div class="block">Create a new session with a given package path</div>
</li>
</ul>
<a name="BrowserSession(java.lang.String[], xdc.services.global.Env)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>BrowserSession</h4>
<pre>public&nbsp;BrowserSession(java.lang.String[]&nbsp;dirs,
              xdc.services.global.Env&nbsp;env)</pre>
<div class="block">Create a new session with a given package path and environment</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getVers()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getVers</h4>
<pre>public&nbsp;int&nbsp;getVers()</pre>
<div class="block">This function is a replacement for simply reading cmd.Builder.GREEN_VERS.
 GREEN_VERS is the value from cmd.Builder that was loaded when this class
 was compiled. That works well in the usual case where all packages are
 coming from the same version of XDCtools. However, XGconf sometimes mixes
 core Java classes from the latest release with packages from an older
 XDCtools release specified for a particular project. In that case, we
 want to use the green version number that corresponds to the project's
 XDCtools release. All packages are most likely built with that version of
 XDCtools and there is no reason to rebuild all packages for the latest
 version of XDCtools just because some of the core classes from that
 release are being used.</div>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code><a href="../../../xdc/services/spec/Session.html#getVers()">getVers</a></code>&nbsp;in class&nbsp;<code><a href="../../../xdc/services/spec/Session.html" title="class in xdc.services.spec">Session</a></code></dd>
</dl>
</li>
</ul>
<a name="findPkg(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findPkg</h4>
<pre>public&nbsp;<a href="../../../xdc/services/spec/Pkg.html" title="class in xdc.services.spec">Pkg</a>&nbsp;findPkg(java.lang.String&nbsp;qn)</pre>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code><a href="../../../xdc/services/spec/Session.html#findPkg(java.lang.String)">findPkg</a></code>&nbsp;in class&nbsp;<code><a href="../../../xdc/services/spec/Session.html" title="class in xdc.services.spec">Session</a></code></dd>
</dl>
</li>
</ul>
<a name="isCurrentPkg(xdc.services.spec.Pkg)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isCurrentPkg</h4>
<pre>public&nbsp;boolean&nbsp;isCurrentPkg(<a href="../../../xdc/services/spec/Pkg.html" title="class in xdc.services.spec">Pkg</a>&nbsp;pkg)</pre>
</li>
</ul>
<a name="isCurrentPkg(java.lang.String, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isCurrentPkg</h4>
<pre>public&nbsp;boolean&nbsp;isCurrentPkg(java.lang.String&nbsp;cpath,
                   java.lang.String&nbsp;qn)</pre>
</li>
</ul>
<a name="loadPkg(java.lang.String, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>loadPkg</h4>
<pre>public&nbsp;<a href="../../../xdc/services/spec/Pkg.html" title="class in xdc.services.spec">Pkg</a>&nbsp;loadPkg(java.lang.String&nbsp;dir,
          java.lang.String&nbsp;qn)</pre>
</li>
</ul>
<a name="isPkgDir(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isPkgDir</h4>
<pre>public&nbsp;java.lang.String&nbsp;isPkgDir(java.lang.String&nbsp;dir)</pre>
<div class="block">Check whether the named directory contains a built package.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>dir</code> - the pathname to the directory to check.</dd>
<dt><span class="strong">Returns:</span></dt><dd>the fully qualified package name, or else null if the
    directory is not recognizably a built package.</dd></dl>
</li>
</ul>
<a name="loadUnit(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>loadUnit</h4>
<pre>public&nbsp;<a href="../../../xdc/services/spec/Unit.html" title="class in xdc.services.spec">Unit</a>&nbsp;loadUnit(java.lang.String&nbsp;name)</pre>
<div class="block">Load the named unit's spec object by searching the package path.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>name</code> - Package-qualified name of the module or interface.</dd>
<dt><span class="strong">Returns:</span></dt><dd>unit, or null if not found.</dd></dl>
</li>
</ul>
<a name="scanDirectories()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>scanDirectories</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;scanDirectories()</pre>
<div class="block">Return a Map of package names indexed by the canonical path to
 the package's base.</div>
</li>
</ul>
<a name="scanRepositories()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>scanRepositories</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;scanRepositories()</pre>
<div class="block">Return a Map all package base directories indexed by the package's
 name.</div>
</li>
</ul>
<a name="setLoadDocs(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setLoadDocs</h4>
<pre>public&nbsp;void&nbsp;setLoadDocs(boolean&nbsp;loadDocs)</pre>
<div class="block">Set whether this session should preserve docs in Nodes.

 If false, spec objects loaded by this session will not
 contain documentation. This is a Java heap memory
 optimization.

 Default is to load documentation.</div>
</li>
</ul>
<a name="getLoadDocs()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getLoadDocs</h4>
<pre>public&nbsp;boolean&nbsp;getLoadDocs()</pre>
<div class="block">Return whether documentation is available in this session.

 Default is to load documentation.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../xdc/services/spec/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../xdc/services/spec/Attr.html" title="class in xdc.services.spec"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../xdc/services/spec/Cache.html" title="class in xdc.services.spec"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?xdc/services/spec/BrowserSession.html" target="_top">Frames</a></li>
<li><a href="BrowserSession.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields_inherited_from_class_xdc.services.spec.Session">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
